/*
**  this file contains most of the key word
**  statements such as for, while, break, etc.
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
/*DEFINE*/
#define		MULDIV	DA
#define		ADDSUB	DB
#define		RELR	DC
#define		EQNE	DD
#define		SHIFT	DE
/**/
/*EXTERNAL*/
#ifdef	CAN_PROTO
#else
#endif	CAN_PROTO
/**/
char    *
whilecomp(is)
char    *is;
{
    auto        INST    *p0;
    auto        INST    *p1;
    auto        INST    *p2;
    auto		char    *isx = is;
/*
**  code[0]     xwhile
**  code[1]     test expression
**  code[1]     statement
**  code[2]     next code
*/
    addcode( (FUNCP) xwhile,"xwhile");
    p0 = addcode(XSTOP,"jump");
    p1 = addcode(XSTOP,"jump");
    p2 = addcode(XSTOP,"jump");
    *p0 = (INST) retrcode();
    isx = exprcomp(++isx);		/* 88:11:20 */
	addcode( (FUNCP) xdtol,"xdtol");
    addcode(XSTOP,"XSTOP");
    *p1 = (INST) retrcode();
    if(*isx++ != ')')   
		errptr(is,"whilecomp <missing right paren>");
    isx = statecomp(isx);		/* 88:11:20 */
    addcode(XSTOP,"XSTOP");
    *p2 = (INST) retrcode();
    return(skipbs(isx));
}
char    *
ifcomp(is)
char    *is;
{
    auto    INST    *p0 = NULL;
    auto    INST    *p1 = NULL;
    auto    INST    *p2 = NULL;
    auto    INST    *p3 = NULL;
    REG     char    *isx = skipbs(is+1);
    addcode( (FUNCP) xif,"xif");
    p0 = addcode(XSTOP,"jump");
    p1 = addcode(XSTOP,"jump");
    p2 = addcode(XSTOP,"jump");
    p3 = addcode(XSTOP,"jump");
    *p0 = (INST) retrcode();
/**/
    isx = exprcomp(isx);			/* conditional part */
	addcode( (FUNCP) xdtol,"xdtol");
    addcode(XSTOP,"XSTOP");
    *p1 = (INST) retrcode();
    if(*isx++ != ')')   errptr(is,"ifcomp <missing right paren>");
/**/
    isx = statecomp(skipbs(isx));	/* affirmative statement */
    addcode(XSTOP,"XSTOP");
    *p3 = *p2 = (INST) retrcode();
/**/
    isx = skipbs(isx);
    if(strncmp(isx,"else",4) == 0)  {		/* else */
        isx = statecomp(skipbs(isx+4));
        addcode(XSTOP,"XSTOP");
        *p3 = (INST) retrcode();
        }
/**/
    return(skipbs(isx));
}
char    *
forcomp(is)
char    *is;
{
    auto    char    *ser = "forcomp <syntax error>";
    auto    INST    *p0 = NULL;
    auto    INST    *p1 = NULL;
    auto    INST    *p2 = NULL;
    auto    INST    *p3 = NULL;
    auto    INST    *p4 = NULL;
    REG     char    *isx = skipbs(is+1);
/*
**  code[0]     xfor
**  code[1]     expr2
**  code[2]     expr3
**  code[3]     statement
**  code[4]     next code
**  code[5]     expr1
*/
    addcode( (FUNCP) xfor,"xfor");
    p0 = addcode(XSTOP,"jump");
    p1 = addcode(XSTOP,"jump");
    p2 = addcode(XSTOP,"jump");
    p3 = addcode(XSTOP,"jump");
    p4 = addcode(XSTOP,"jump");
    *p0 = (INST) retrcode();
    isx = exprcomp(isx);                /* expr 1 */
    addcode(XSTOP,"XSTOP");
    if(*isx++ != ';')   errptr(is,ser);
    *p1 = (INST) retrcode();
    isx = exprcomp(isx);                /* expr 2 */
/**/
	addcode( (FUNCP) xdtol,"xdtol");
/**/
    addcode(XSTOP,"XSTOP");
    if(*isx++ != ';')   errptr(is,ser);
    *p2 = (INST) retrcode();
    isx = exprcomp(isx);                /* expr 3 */
    addcode(XSTOP,"XSTOP");
    if(*isx++ != ')')   errptr(is,ser);
    *p3 = (INST) retrcode();
    isx = statecomp(skipbs(isx));       /* body statement */
    addcode(XSTOP,"XSTOP");
    *p4 = (INST) retrcode();
    return(skipbs(isx));
}
char	*
semicolon(is)		/* skip ';' for break and continue */
char	*is;
{
	REG		char	*isx = is;
	while(isspace(*isx) || *isx == ';')	++isx;
	return(isx);
}
char    *
contcomp(is)        /* continue statement */
char    *is;
{
    REG     char    *isx = is;
    addcode( (FUNCP) xcontinue,"xcontinue");
    addcode(XSTOP,"XSTOP");
    return(semicolon(isx));
}
char    *
breakcomp(is)       /* break statement */
char    *is;
{
    REG     char    *isx = is;
    addcode( (FUNCP) xbreak,"xbreak");
    addcode(XSTOP,"XSTOP");
    return(semicolon(isx));
}
char    *
lorcomp(is)     /* compile logical lor */
char    *is;
{
    REG		    char    *isx = is;
    auto        INST    *p0 = NULL;
/**/
    isx = landcomp(isx);
/**/
    while(isx && (int) (isx = skipbs(isx)))
    if(strncmp(isx,"||",2) == 0)    {
		addcode( (FUNCP) xdtol,"xdtol");	/* 88:11:20 */
        addcode( (FUNCP) xlor,"xlor");
        p0 = addcode(XSTOP,"jump");
        isx = landcomp(isx + 2);
		addcode( (FUNCP) xdtol,"xdtol");
        addcode(XSTOP,"XSTOP");
        *p0 = (INST) retrcode();
        }
    else    break;
    return(isx);
}
char    *
landcomp(is)    /* compile logical and */
char    *is;
{
    REG		    char    *isx = is;
    auto        INST    *p0 = NULL;
    isx = bwiocomp(isx);
    while(isx && (int) (isx = skipbs(isx)))
    if(strncmp(isx,"&&",2) == 0)    {
		addcode( (FUNCP) xdtol,"xdtol");	/* 88:11:20 */
        addcode( (FUNCP) xland,"xland");
        p0 = addcode(XSTOP,"jump");
        isx = bwiocomp(isx + 2);
		addcode( (FUNCP) xdtol,"xdtol");
        addcode(XSTOP,"XSTOP");
        *p0 = (INST) retrcode();
        }
    else    break;
    return(isx);
}
char	*		/* bitwise inclusive or | */
bwiocomp(is)
char	*is;
{
	auto	char	*isx;
	isx = bwxocomp(isx = is);
	while(isx && (int) (isx = skipbs(isx)))
	if(*isx == '|' && isx[1] != '|')	{
		isx = bwxocomp(++isx);
		addcode( (FUNCP) xbwio, "xbwio");
		}
	else	break;
	return(isx);
}
char	*
bwxocomp(is) 	/* bitwise exclusive or ^ */
char	*is;
{
	auto	char	*isx;
	isx = bwandcomp(isx = is);
	while(isx && (int) (isx = skipbs(isx)))
	if(*isx == '^' && isx[1] != '^')	{
		isx = bwandcomp(++isx);
		addcode( (FUNCP) xbwxo, "xbwxo");
		}
	else	break;
	return(isx);
}
char	*		/* bitwise and & */
bwandcomp(is)
char	*is;
{
	auto	char	*isx;
	isx = eqnecomp(isx = is);
	while(isx && (int) (isx = skipbs(isx)))
	if(*isx == '&' && isx[1] != '&')	{
		isx = eqnecomp(++isx);
		addcode( (FUNCP) xbwand, "xbwand");
		}
	else	break;
	return(isx);
}
char    *
eqnecomp(is)    /* compile equality !equality */
char    *is;
{
	auto	char	*isx = NULL;
    is = relrcomp(is);
	while(is && (int) (is = skipbs(is)) &&
		(int) (isx = newcomp(is,EQNE)))	is = isx;
	return(is);
}
char    *
relrcomp(is)    /* compile relations < <= => > */
char    *is;
{
    auto    char    *isx = NULL;
/**/
    is = shiftcomp(is);
/**/
	while(is && (int) (is = skipbs(is)) &&
		(int) (isx = newcomp(is,RELR)))	is = isx;
	return(is);
}
char    *
shiftcomp(is)
char    *is;
{
    auto    char    *isx = NULL;
    is = addsubcomp(is);
	while(is && (int) (is = skipbs(is)) &&
		(int) (isx = newcomp(is,ADDSUB)))	is = isx;
	return(is);
}
char    *
addsubcomp(is)
char    *is;
{
    auto    char    *isx = NULL;
    is = muldivcomp(is);
	while(is && (int) (is = skipbs(is)) &&
		(int) (isx = newcomp(is,ADDSUB)))	is = isx;
	return(is);
}
char    *
muldivcomp(is)
char    *is;
{
    auto    char    *isx = NULL;
    is = tokencomp(is);
	while(is && (int) (is = skipbs(is)) &&
		(int) (isx = newcomp(is,MULDIV)))	is = isx;
	return(is);
}
/*===CHECK===*/
typedef	struct OPCOMP {
	char	*opn;
	int		oty;
	int		ops;
	char	*((*opf)());
	FUNCP   stf;
	char	*stn;
	}	OPCOMP;
OPCOMP	opc[] = {
	"<<", SHIFT, 2, addsubcomp, (FUNCP) xbwleft, "xbwleft",
	">>", SHIFT, 2, addsubcomp, (FUNCP) xbwright, "xbwright",
	"==", EQNE, 2, relrcomp, (FUNCP) eeq, "eeq",
	"!=", EQNE, 2, relrcomp, (FUNCP) ene, "ene",
	"<=", RELR, 2, shiftcomp, (FUNCP) elte, "elte",
	">=", RELR, 2, shiftcomp, (FUNCP) egte, "egte",
	">", RELR, 1, shiftcomp, (FUNCP) egt, "egt",
	"<", RELR, 1, shiftcomp, (FUNCP) elt, "elt",
	"-", ADDSUB, 1, muldivcomp, (FUNCP) esub, "esub",
	"+", ADDSUB, 1, muldivcomp, (FUNCP) eadd, "eadd",
	"*", MULDIV, 1, tokencomp, (FUNCP) emul, "emul",
	"/", MULDIV, 1, tokencomp, (FUNCP) ediv, "ediv",
	"%", MULDIV, 1, tokencomp, (FUNCP) emod, "emod",
	}	;
OPCOMP	*opb = opc;
OPCOMP	*opu = opc + (sizeof(opc)/sizeof(OPCOMP));
char	*
curline(os,is)
char	*os;
char	*is;
{
	REG		char	*isx = is;
	if(!isnull(os))	printf("%-10.10s ",os);
	while(*isx != ZERO && *isx != LF)	fputc(*isx++,stdout);
	fputc(LF,stdout);
	return(ZERO);
}
char	*
newcomp(is,ty)
char	*is;
NOSIGN	ty;
{
	REG		OPCOMP	*opx = opb;
	is = skipbs(is);
	while(opx < opu)	{
		if(ty == opx->oty &&
			strncmp(is,opx->opn,opx->ops) == 0)	{
				is = (*opx->opf)(is + opx->ops);
				addcode(opx->stf,opx->stn);
				is = skipbs(is);
				return(is);
			}
	opx += 1;
	}
	return(NULL);
}
