#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/*
**	89:01:30	changed trap array to char for SUN, fixed nt
				command
**	86:10:10	corrected .bp command
*/
#if	HUGE == 9999
#undef	HUGE
#define	HUGE 	(((unsigned) ~0) >> 1)
#endif
/*EXTERNAL*/
#define     NTRAP       132
#define     NTRAP       264
#define		LEFTS		8
#define		INTCHR(a,b)((a | (b << LEFTS)))
#define     macname(a,b)((isalpha(a) && isalnum(b))?1:0)
#define     frombot(a,b)(( a < 0 ) ? (b + a + 1) : a)
/*
*/
static      char    *msg1 = "<bad trap> '%s'\n";
static      char 	trap[NTRAP];		/* should be 16 bits */
/*
**	nt should be global
*/
int			nt		=	0;
/*
*/
xwh(nv,is)                  /* .wh XX nn */
char    *is;
{
	return(xwh1(psget(),zvp(nv,is)));
}
void
badtrap(vp)
int		vp;
{
	if(vp < 0 || vp >= NTRAP)	{
		errmsg("badtrap <illegal vertical position> %d\n",vp);
		terror(FUBAR);
		}
	return;
}
xwh1(is,vp)                 /* is = name, vp = place */
char    *is;
{
	vp *= 2;
	badtrap( vp );
#ifdef	DEBUG
fprintf(stderr,"xwh1: vp(%d)\n",vp);
#endif	/*DEBUG*/
	if(isnull(is) || macname(is[0],is[1]))  {
		strncpy(trap + vp, is, 2);
#ifdef	DEBUG
fprintf(stderr,"xwh1: trap(%2.2s)\n",trap + vp);
#endif	/*DEBUG*/
		}
	else {
		errmsg(msg1,savecmd((char *) NULL));
		filewalk();
	}
}
xch(nv,is)              /* change, delete trap */
char    *is;
{
	REG		NOSIGN	ix;
	auto	int		vp;
	auto	char	*nmx;
/*
|	ch macro pos
*/
	if(nv >= 1)		badenv(nv,"xch",FUBAR);
/**/
	while(isspace(*is))    ++is;
/**/
	nmx = is;
/**/
#ifdef	DEBUG
fprintf(stderr,"xch: xnm(%2.2s)\n",nmx);
#endif	/*DEBUG*/
	for(ix = 0; ix < sizeof(trap); ix += 2)	{
		if(trap[ix] == is[0] &&
			trap[ix+1] == is[1]) {
				trap[ix] = trap[ix+1] = ZERO;
#ifdef	DEBUG
fprintf(stderr,"xch: ix(%u)\n",ix);
#endif	/*DEBUG*/
				}
		}
	for(is += 2; isspace(*is) ; ++is) ;
	vp = zvp(nv,is);
#ifdef	DEBUG
fprintf(stderr,"xch: vp(%d)\n",vp);
#endif	/*DEBUG*/
	return(xwh1(nmx,vp));
}
zvp(nv,is)
char	*is;
{
	auto	int		vp;
	if(*is == '-')
		vp = -setvar(nv,++is,VERT,x[nv].vp,x[nv].vp);
	else
	if(*is == '+')
		vp = setvar(nv,++is,VERT,x[nv].vp,x[nv].vp);
	else
		vp = setvar(nv,is,VERT,x[nv].vp,x[nv].vp);
	vp = frombot(vp,x[nv].pl);
	return(vp);
}
xpt(nv,is)                  /* print traps (diagnostic) */
char    *is;
{
	REG     FILE        *fp = stderr;
	REG		NOSIGN		ix;
	if(*is == 't')      fp = x[nv].ofp;
	else
	if(*is == 'e')      fp = stderr;
	fflush(x[nv].ofp);
#ifdef	DEBUG
fprintf(stderr,"xpt: is(%s)\n",is);
#endif	/*DEBUG*/
	for(ix = 0; ix < sizeof(trap); ix += 2)	{
#ifdef	DEBUG
fprintf(stderr,"xpt: ix(%d) trap(%2.2s)\n",ix,trap + ix);
#endif	/*DEBUG*/
	if(trap[ix])	{
		if(fp == stderr)	{
			fprintf(fp,"%3d %2.2s\n",ix,trap+ix);
			}
		else	{
			auto	char	ws[FNMSIZ];
			sprintf(ws,"%3d %2.2s",ix,trap+ix);
			tblwrt(nv,ws);
			}
		}
	}
	fflush(fp);
	return(0);
}
xzt(nv,is)  /* clear all */
char    *is;
{
	memset( trap, ZERO, sizeof(trap));
	return(0);
}
xnt(nv,is)      /* distance to next trap or bottom of page */
char    *is;
{
/*
**	distance to next trap is calculated only when requested
**	nt is NOT an environment variable
**	if on a trap (usual case) add 1
*/
	if(nv >= 1)		nt = HUGE;
	else			nt = znt(nv,x[nv].vp);
#ifdef	DEBUG
	fprintf(stderr,"nt %u\n",nt);
#endif
}
znt(nv,vp)      /* distance to next trap or bottom of page */
int		nv;
int		vp;
{
	REG		char	*tx;
	REG		char	*tu = trap + (x[nv].pl * 2);
	auto	int		xvp = vp * 2;
	badtrap( xvp );
	if(trap[xvp])	xvp += 2;
	for(tx = trap + xvp; tx <= tu; tx += 2)
		if(*tx)	return( (tx - (trap + xvp)) / 2);
	return(x[nv].pl - vp);
}
trapat(nv,vp)           /* trip trap */
{
	static	char	*lt = NULL;
	if(nv != 0)         return(ZERO);       /* diversion */
	vp *= 2;
	badtrap( vp );
	if(trap[vp] && lt != (trap + vp))	{
		lt = trap + vp;
		spring(nv,trap + vp);
		lt = NULL;
		return(1);
		}
	else    {
		lt = NULL;
		return(0);
		}
}
spring(nv,is)
char    *is;
{
	char    ws[4];
	ws[0] = '.';
	ws[1] = is[0];
	ws[2] = is[1];
	ws[3] = ZERO;
	return(isolate(nv,ws,1));
}
begintext(nv)           /* beginning of text functions */
{
	if(nv <= 0 && ol)   {
		zsi(nv,si = 1);
		if(inlist(x[nv].cp))    zsi(nv,si = 0);
		else                    zsi(nv,si = 1);
		}
	return(1);
}
linepage(nv,vm)         /* line and page counts */
{
	static          int     set = 0;
	if(set <= 0)    set = begintext(nv);
	if(vm >= 1) {
		if(x[nv].di)        dl_add(x[nv].di-1,1);
		x[nv].vp += 1;      /* vertical pos */
		x[nv].lo += 1;      /* total lines out */
		if(nv <= 0 && sl
			&& (x[nv].lo % sl == 0))    sl = zsl(nv,x[nv].lo);
/*
**  assumes lines are numbered 0 through pl-1
*/
		if(x[nv].vp >= x[nv].pl)    {
/*          end of page transition */
			x[nv].cp = x[nv].pn;
			x[nv].pn += 1;
			x[nv].tp += 1;  /* total pages out */
			x[nv].vp = 0;
			}
		if(x[nv].vp <= 0)   {
			pagetop(nv);
			}
		return(x[nv].vp);
		}
	else    
	if(vm == 0)     return(x[nv].vp);
	else            return(--x[nv].vp);
}
pagetop(nv)             /* top of page functions */
{
	auto    int     nr;
/*
**  check for page list
*/
	if(nv <= 0 && ol)   {
		nr = inlist(x[nv].cp);
		if(nr >= 1) zsi(nv,si = 0);
		else
		if(nr == 0) zsi(nv,si = 1);
		else        { cleanup(0); exit(0); }
		}
	return(ZERO);
}
xne(nv,is)              /* need function */
char    *is;
{
	auto    int ne;
	auto    int nt;
/*
**	no traps in diversions; no traps in environment
**	other than 0
*/
	if(nv >= 1)	return(0);
	ne = setvar(nv,is,VERT,0,1);
	nt = znt(nv,x[nv].vp);
	ne = ne <= 0 ? 1 : ne;
	if(nt < ne) return(zsp(nv,ne));
	else        return(0);
}
xbp(nv,is)              	/* begin page */
char    *is;
{
	auto	int		cp;
/*
**	do break; skip to bottom of page
*/
	if(x[nv].br >= 1 && x[nv].osx > x[nv].os)	xbr(nv,is);
	x[nv].br = 0;
	if(x[nv].vp >= 1)	zsp(nv,x[nv].pl-x[nv].vp);
/*
**	set current page; set next page
*/
	x[nv].cp = setvar(nv,is,ABSO,x[nv].cp,x[nv].cp+1);
	x[nv].pn = x[nv].cp + 1;
	return(x[nv].cp);
}
xsp(nv,is)              /* vertical spacing */
char    *is;
{
	return(zsp(nv,setvar(nv,is,VERT,0,1)));
}
zsp(nv,sp)
{
	REG     int     spx = sp;
	REG     int     vp = x[nv].vp;
	if(spx < 0)     spx = spx > vp ? vp : spx;
	if(x[nv].br >= 1 && x[nv].osx > x[nv].os)	xbr(nv,"zsp");
	x[nv].br = 0;
	if(spx >= 1)    {
		while(spx-- >= 1)   {
			if(trapat(nv,x[nv].vp)) break;
			putc('\n',x[nv].ofp);
			linepage(nv,1);
			if(x[nv].vp <= 0)		break;
			}
	}
	else
	if(spx < 0)     {
		while(x[nv].vp >= 1 && spx++ <= 0)   {
			putc(VRV,x[nv].ofp);
			linepage(nv,1);
			}
	}
	fflush(x[nv].ofp);
	return(x[nv].vp);
}
xls(nv,is)                  /*  line spacing */
char    *is;
{
	return(x[nv].ls = setvar(nv,is,VERT,x[nv].ls,DLS));
}
xlo(nv,is)
char    *is;
{
	return(x[nv].lo = setvar(nv,is,HORZ,x[nv].lo,0));
}
xnm(nv,is)
char    *is;
{
	return(x[nv].nm = setvar(nv,is,ABSO,x[nv].nm,1));
}
xnn(nv,is)
char    *is;
{
	return(x[nv].nn = setvar(nv,is,ABSO,x[nv].nn,1));
}
xns(nv,is)
char    *is;
{
	return(x[nv].nn = setvar(nv,is,ABSO,0,1));
}
xsv(nv,is)
char    *is;
{
/*NOT*/
	return(x[nv].sv = setvar(nv,is,VERT,x[nv].sv,1));
}
xvp(nv,is)      /* set vertical position */
char    *is;
{
/*DEFAULT?*/
	return(x[nv].vp = setvar(nv,is,VERT,x[nv].vp,0));
}
#ifdef      TEST
setenv(nv)
{
	x[nv].ofp = stdout;
	x[nv].pl = 22;
}
main()
{
	char    ls[BLKSIZ];
	setenv(0);
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(kase(ls))    {
	KASE('v','p'):          printf("vp = %2d\n",x[0].vp);break;
	KASE('a','l'):          linepage(0,atoi(ls+2));break;
	KASE('k','k'):          exit(0);
	KASE('!','!'):          system(ls+2);break;
	KASE('w','h'):          xwh(0,ls+2);break;
	KASE('c','h'):          xch(0,ls+2);break;
	KASE('p','t'):          xpt(0,ls+2);break;
	KASE('z','t'):          xzt(0,ls+2);break;
	KASE('n','t'):          printf("%d\n",znt(0,x[0].vp));
						break;
	KASE('s','p'):          xsp(0,ls+2);break;
	KASE('b','p'):          xbp(0,ls+2);break;
	KASE('z','z'):          zzz(atoi(ls+2));break;
	KASE('n','e'):          xne(0,ls+2);break;
	}
	exit(0);
}
#endif
