/*DOSLIB*/
/*UNXLIB*/
/*
	WARNING
	the sut/gut mechanism is fragile and perhaps buggy.  complications
	come from different handling of daylight saving time

	the utime used here is from the Quick-C library
*/
/**/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include   	<time.h>
#include    <sys/types.h>
#include    <sys/stat.h>
/**/
/*EXTERNAL*/
extern	KENV		kenv;
/*GLOBAL*/
static	struct	stat	sb;		/* stat buf */
/**/
#ifdef		MSDOS
/**/
#include	<dos.h>
/**/
void
diskreset()		/* force a reset */
{
	auto	union	REGS	regi;
	regi.h.ah = 0x0d;	/* disk reset */
	intdos(&regi,&regi);
}
long
gdf(dr)			/* get disk space free on _dr */
{
	auto	union	REGS	regi;
	auto	long	df;
	dr = upperit(dr);
	dr = (dr > 26) ? (dr - '@') : dr;
	regi.h.ah = 0x36;	/* disk free space */
	regi.h.dl = dr;
	intdos(&regi,&regi);
	if(regi.x.ax == 0xffff)	{
		errmsg("gdf <invalid drive> '%d'\n",dr);
		return(0L);
		}
	df = (long) regi.x.ax * (long) regi.x.bx * (long) regi.x.cx;
	return(df);	
}
#else
long
gdf(dr)
{
	return(0L);
}
void
diskreset()
{
}
#endif
long
fileatime(fn)       /* return access time (raw) */
char    *fn;
{
	if(stat(fn,&sb) < 0)    return( (long) -1 );
	else                    return( sb.st_atime );
}
fileinode(fn)       /* return inode */
char    *fn;
{
	if(kenv.dosdos)			return(1);
	if(stat(fn,&sb) < 0)    return( -1 );
	else                    return(sb.st_ino);
}
char	*
filemtime(fn)
char	*fn;
{
	return(filemod(fn));
}
char    *
filemod(fn)     /* fn = file name as a string */
char *fn;
{
	static  char    mt[32];
	struct  stat    x;
	struct  tm  *t, *localtime();
/*
	return file modification time in
	41-12-07 07:00 format
*/
	if(stat(fn,&x) < 0 ) return(NULL);
	t = localtime(&x.st_mtime);
	sprintf(mt,"%d-%02d-%02d %02d:%02d",
		t->tm_year, t->tm_mon+1, t->tm_mday,
		t->tm_hour, t->tm_min);
	return(mt);
}
long    
filemraw(fn)       /* return modification time (raw) */
char    *fn;
{
	if(stat(fn,&sb) < 0)    return( (long) -1 );
	else                    return( sb.st_mtime );
}
unsigned
fileperm(fn)        /* return mode (permission) */
char    *fn;
{
	if(stat(fn,&sb) < 0)    return( ~0 );
	else                    return(sb.st_mode);
}
long
filesize(fn)    /* return file size from stat function */
char *fn;
{
/*
	MSDOS-BUG:  file size is inaccurate when file is open.
*/
	if(stat(fn,&sb) >= 0) return(sb.st_size);
	else return(-1L);
}
haslinks(fn)	/* return number of links to _fn */
char *fn;
{
	if(kenv.dosdos)			return(1);
	if(stat(fn,&sb) >= 0) 	return(sb.st_nlink);
	else 					return(-1);
}
long
gut(fn)		/* save the current file time */
char	*fn;
{
	return(gux(fn,(NOSIGN) 0));
}			
long
sut(fn) 	/* set the current file time to a saved time */
char	*fn;
{
	return(gux(fn,1));
}
long
gux(fn,ty)	/* time set function for files */
NOSIGN	ty;
char	*fn;
{
	static	time_t	cft[2];
	auto	long	ret;
/*
	maybe problems in MSDOS if file is not open when time
	is changed.
*/
/**/
	if(ty == 0) {
		ret = cft[0] = cft[1] = filemraw(fn);
		}
	else
	if(ty == 1)	{
		ret = utime(fn,cft);
		}
/**/
	return(ret);
}
