/*DOSLIB*/
#define		XTAB
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<signal.h>
#include	<setjmp.h>
#define		MENU	1
#define		COMM	2
#define		MECO	(MENU | COMM)
#define		NOSIGN	unsigned
#define		TB		'\t'
#define		SP		' '
/*EXTERN*/
extern	long	time();
extern	void	wrmenu();
extern	void	xex();
extern	void	xco();
extern	void	xbe();
extern	void	xqu();
extern	void	xpl();
extern	void	xfi();
extern	void	xgo();
extern	void	xcl();
extern	void	xlf();
extern	char	*fgetlt();
/*STATIC*/
KENV	kenv;
static	NOSIGN	copies = 1;
static	NOSIGN	length = 66;
static	NOSIGN	qupage = 500;
static	NOSIGN	bepage = 0;
static	char	*flist = NULL;
static	char	*lpt =	"/dev/com1";
static	char	ls[BUFSIZ];
static	char	*lsu = ls + BUFSIZ - 1;
static	jmp_buf	belch;
/**/
struct	COMMAND	{
	char	*sv;
	int		ty;
	char	*cn;
	char	*ds;
	FUNCP	fu;
	char	*cx;
	}	co[] = {
	NULL,MECO,"be","0", (FUNCP) xbe,"specify starting sheet",
	NULL,MECO,"cl",NULL, (FUNCP) xcl,"clear screen for menu",
	NULL,MECO,"co","1", (FUNCP) xco,"specify number of copies if not 1",
	NULL,MECO,"ex",NULL, (FUNCP) xex,"exit this program",
	NULL,MECO,"fi",NULL, (FUNCP) xfi,"specify list of files to print",
	NULL,MECO,"go",NULL, (FUNCP) xgo,"begin printing",
	NULL,MECO,"lf","b:*.*", (FUNCP) xlf,"list files on named disk",
	NULL,MECO,"pl","66", (FUNCP) xpl,"specify page length if not 66 lines/page",
	NULL,MECO,"qu","500", (FUNCP) xqu,"specify ending sheet",
	NULL,ZERO,NULL,NULL,NULL,NULL,
	}	;
void
xlf(is)
char	*is;
{
	auto	char	*fl;
	auto	NOSIGN	nf = ZERO;
	auto	char	*fx;
	strlwr(is);
	if(strcmp(is,"a:") == ZERO)	is = "a:*.*";
	else
	if(strcmp(is,"b:") == ZERO)	is = "b:*.*";
	fl = xpandsh(is,NULL);
	is = fl;
	while((int)(is = xgnc(ls,ls+FNMSIZ-1,is,' ')))	{
		fx = rindex(ls,'/');
		if(fx)	++fx;
		else	fx = ls;
		fprintf(stderr,"%14.14s ",fx);
		nf += 1;
		if(nf >= 4)	{
			fprintf(stderr,"\n");
			nf = ZERO;
			}
		}
	if(nf)	fprintf(stderr,"\n");
	fl = free_if(fl);
	query(stderr);
}
void
xcl(is)
char	*is;
{
	scr_cl(stderr);
/* ### Warning lps.c 91: Parameter 'is' is never used in function xcl === */
}
void
xgo(is)
char	*is;
{
	auto	char	fn[FNMSIZ];
	auto	FILE	*fp = NULL;
	auto	NOSIGN	beline;
	auto	NOSIGN	quline;
	auto	NOSIGN	rdline;
	auto	long	start;
	auto	long	tused;
	auto	long	prate;
	auto	long	pages;
	is = flist;
	if(isnull(flist))	{
/* ### Warning lps.c 107: Call to function 'errmsg' with no prototype in function xgo === */
		errmsg("<no file list>\n");
		kenv.prompt = 5;
		return;
		}
	fprintf(stdout,"\033&l%X",copies);
	while((int)(is = xgnc(fn,fn+FNMSIZ-1,is,' ')))	{
		fp = xfclose(fp);
		if(!(int) (fp = efopen(fn,"rb")))	{
			fubar(FUBAR);
			kenv.prompt = 5;
			}
		time(&start);
		rdline = ZERO;
		beline = bepage * length;
		quline = qupage * length;
#ifdef	XTAB
/* ### Warning lps.c 123: Call to function 'fgetlt' with no prototype in function xgo === */
		while(fgetlt(ls,lsu,fp))	{
#else	XTAB
		while(fgetlf(ls,lsu,fp))	{
#endif	XTAB
			rdline += 1;
			if(rdline > quline)		break;
			if(rdline < beline)		continue;
			puts(ls);
			if((rdline % length) == ZERO) 	{
				pages = rdline/length;
				tused = time(NULL) - start;
				prate = tused / pages;
				fprintf(stderr,"%3ld %3ld %-64.64s\r",pages,prate,fn);
			}
		}
		fprintf(stderr,"FINISHED %-64.64s\r",fn);
	}
	fp = xfclose(fp);
	return;
}
char	*
fgetlt(os,us,fp)
char	*os;
char	*us;
FILE	*fp;
{
	REG		int		cx;
	REG		char	*osx = os;
	REG		char	*usx = us;
	while(osx < usx && (cx = getc(fp)) != EOF)	
	if(cx == CR)	continue;
	else
	if(cx == LF)	break;
	else
	if(cx == TB)	{
		REG		int		tb = 8;
		while(osx < usx && tb-- >= 1)	*osx++ = SP;
		}
	else			*osx++ = cx;
	*osx = ZERO;
	return(cx == EOF ? NULL : os);
}
void
xfi(is)
char	*is;
{
	auto	int		err = ZERO;
	auto	FILE	*fp;
	flist = free_if(flist);
	is = flist = xpandsh(is,NULL);
	while((int)(is = xgnc(ls,ls+FNMSIZ-1,is,' ')))	{
		fp = efopen(ls,"r");
		if(!fp)	{
			err += 1;
			kenv.prompt = 5;
			}
		fp = xfclose(fp);
		}
	if(err)	flist = free_if(flist);
	fp = xfclose(fp);
	return;
}
void
xbe(is)
char	*is;
{
	bepage = atoi(is);
	return;
}
void
xqu(is)
char	*is;
{
	qupage = atoi(is);
	return;
}
void
xpl(is)
char	*is;
{
	length = atoi(is);
	return;
}
void
xco(is)
char	*is;
{
	copies = atoi(is);
	return;
}
void
xex(is)
char	*is;
{
	exit(atoi(is));
	return;
}
void
wrmenu(ty)
int		ty;
{
	REG		struct	COMMAND	*cox = co;
	if(kenv.prompt)	{
		query(stderr);
		}
	kenv.prompt = ZERO;
	scr_cl(stderr);
	while(cox->ty)	{
		if(cox->ty & ty)	{
			fputs(cox->cn,stderr);
			fputs("    ",stderr);
			fputs(cox->cx,stderr);
			fputs("\n",stderr);
			if(cox->sv && strlen(cox->sv) <= ZERO)
				cox->sv = free_if(cox->sv);
			if(cox->sv)	{
				fputs("->",stderr);
				fputs("    ",stderr);
				scr_so(stderr);
				fputs(cox->sv,stderr);
				scr_se(stderr);
				fputs("\n",stderr);
				}
			}
		cox += 1;
		}
	return;
}
rdcmd()
{
	REG		struct	COMMAND	*cox;
	auto	int				fo = NO;
	auto	char			*lx = ls + 2;
	while(1)	{
/* ### Warning lps.c 257: Call to function 'wrmenu' with no prototype in function rdcmd === */
	wrmenu(MECO);
	fputs("?? ?????\r",stderr);
	fgetlf(ls,lsu,stdin);
	fo = NO;
	cox = co;
		while(!fo && cox->ty)	{
			if(strncmp(ls,cox->cn,2) == ZERO)	{
				cox->sv = free_if(cox->sv);
				strcnd(lx);
				if(isnull(lx))	cox->sv = strsave(cox->ds);
				else			cox->sv = strsave(lx);
/* ### Warning lps.c 268: Call to function with no prototype in function rdcmd === */
				(*cox->fu)(cox->sv);
				fo = YES;
				}
			cox += 1;
			}
	if(!fo)	{
/* ### Warning lps.c 274: Call to function 'errmsg' with no prototype in function rdcmd === */
		errmsg("<bad command> '%s'\n",ls);
		kenv.prompt = 5;
		}
	}
/* ### Warning lps.c 278: Function should return a value in function rdcmd === */
}
void
terror(ty)
int		ty;
{
	efclean(NULL);
/* ### Warning lps.c 284: Call to function 'errmsg' with no prototype in function terror === */
	errmsg("<INTERRUPTED>\n");
	kenv.prompt = 5;
	longjmp(belch,ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "lps");
#ifdef	DEBUG
	freopen("/dev/null","wb",stdout);
#else	DEBUG
	if(!(freopen(lpt,"wb",stdout)))	{
/* ### Warning lps.c 298: Call to function 'prterr' with no prototype in function main === */
		prterr("%s",lpt);
		}
#endif	DEBUG
	setjmp(belch);
/* ### Warning lps.c 302: Call to function 'setcbrk' with no prototype in function main === */
	setcbrk(1);
	signal(SIGINT,terror);
/* ### Warning lps.c 305: Call to function 'rdcmd' with no prototype in function main === */
	rdcmd();
	exit(ZERO);
/* ### Warning lps.c 307: Parameter 'argv' is never used in function main === */
/* ### Warning lps.c 307: Parameter 'argc' is never used in function main === */
/* ### Warning lps.c 307: Function should return a value in function main === */
}



